package com.hsbc.hbfr.ccf.at.logreader.model;

import org.apache.log4j.Logger;

import javax.swing.*;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.FileNotFoundException;
import java.util.List;

import com.hsbc.hbfr.ccf.at.logreader.ui.ProgressIndicatorNeutral;
import com.hsbc.hbfr.ccf.at.logreader.ui.MessageUtils;

/**
 * Created by IntelliJ IDEA.
 * User: E9310750
 * Date: 10 mai 2005
 * Time: 16:15:53
 * To change this template use File | Settings | File Templates.
 */
public class FileLogReader extends LogReader {
    private static final Logger logger = Logger.getLogger("INFRA."+FileLogReader.class.getName());
    private final String filename;
    private final LogProvider provider;

    public FileLogReader(FileProvider aProvider, File f, ProgressIndicatorNeutral monitor, int min, int max) {
        super(monitor, min, max, f.length());
        provider = aProvider;
        filename = f.getPath();
    }

    public FileLogReader(FileProvider aProvider, String logFilename, ProgressIndicatorNeutral monitor, int min, int max, int totalBytes){
        this(aProvider, new File(logFilename), monitor, min, max);
    }

    public List parse() throws IOException {
        long start = System.currentTimeMillis();
        List l = null;
        try {
            l = super.parse(new FileReader(filename));
        } catch (UnparseableLogFileException e) {
            logger.error(MessageUtils.getErrorMessage(MessageUtils.cant_read_log_file, filename),e);
            throw e;
        } catch (FileNotFoundException e) {
            logger.error(MessageUtils.getErrorMessage(MessageUtils.cant_read_log_file, filename),e);
            throw e;
        }
        long end = System.currentTimeMillis();
        logger.debug("parsed [" + filename + "] in " + (end - start) + " milliseconds");
        return l;
    }

    protected SimpleLogEvent createEvent(String eventString) {
        return new ProvidedEvent(provider, eventString);
    }
}
