package com.hsbc.hbfr.ccf.at.logreader.model;

import org.apache.log4j.Logger;

import java.io.File;
import java.io.IOException;
import java.util.List;

import com.hsbc.hbfr.ccf.at.logreader.ui.ProgressIndicatorNeutral;

/**
 * Created by IntelliJ IDEA.
 * User: Administrateur
 * Date: 5 mai 2005
 * Time: 09:56:28
 * To change this template use File | Settings | File Templates.
 */
public class FileProvider implements LogProvider {
    private static final Logger logger = Logger.getLogger("INFRA."+FileProvider.class.getName());
    private final File f;

    public FileProvider(File f) {
        this.f = f;
    }

    public List getEvents(ProgressIndicatorNeutral monitor, int min, int max) throws IOException {
        if (logger.isDebugEnabled()) {
            logger.debug("loading "+this);
        }
        LogReader r = new FileLogReader(this, f, monitor, min, max);
        return r.parse();
    }

    public boolean isTransient() {
        return false;
    }

    public String toString() {
        return f.toString();
    }

    public int hashCode() {
        return f.hashCode();
    }

    public boolean equals(Object obj) {
        return (obj instanceof FileProvider && f.equals(((FileProvider) obj).f));
    }
}
