package com.hsbc.hbfr.ccf.at.logreader.model;

import com.hsbc.hbfr.ccf.at.logreader.ui.MessageUtils;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.StringTokenizer;

/**
 * Created by IntelliJ IDEA.
 * User: E9310750
 * Date: 27 avr. 2005
 * Time: 14:50:47
 * To change this template use File | Settings | File Templates.
 */
public abstract class SimpleLogEvent implements LogEvent {
	private String eventString;
	private int categoryEnd =-1;
	private int priorityEnd =-1;
	private int threadEnd =-1;
	private int dateEnd=-1;
    private transient Date date;

    private static final SimpleDateFormat dateFormatter;
	public static final String DATE_PATTERN = "yyyy-MM-dd HH:mm:ss,SSS";

	static {
		// 2005-04-28 13:02:07,543
		dateFormatter = new SimpleDateFormat(DATE_PATTERN);
	}

	public SimpleLogEvent(String eventString) {
		this.eventString = eventString;
		categoryEnd = eventString.indexOf(";");
		priorityEnd = eventString.indexOf(";", categoryEnd+1);
		threadEnd = eventString.indexOf(";", priorityEnd+1);
		dateEnd = eventString.indexOf(";", threadEnd+1);
        try {
            date = dateFormatter.parse(getDateString());
        } catch (ParseException e) {
            throw new UnparseableLogFileException(
                    MessageUtils.getErrorMessage(MessageUtils.bad_date_format, getDateString(), DATE_PATTERN));
        }
	}

	public String getString() {
		return eventString;
	}

	public String getCategory() {
		return eventString.substring(0, categoryEnd);
	}

	public String getPriority() {
		return eventString.substring(categoryEnd+1, priorityEnd);
	}

	public String getThread() {
		return eventString.substring(priorityEnd+1, threadEnd);
	}

	public Date getDate() {
        return date;
    }

    private String getDateString() {
        return eventString.substring(threadEnd+1, dateEnd);
    }

    public String getMessage() {
        return eventString.substring(dateEnd+1);
    }
}
