package com.hsbc.hbfr.ccf.at.logreader.model;

import org.apache.log4j.Logger;

import java.io.IOException;
import java.net.URL;
import java.util.List;

import com.hsbc.hbfr.ccf.at.logreader.ui.ProgressIndicatorNeutral;

/**
 * Created by IntelliJ IDEA.
 * User: Administrateur
 * Date: 5 mai 2005
 * Time: 09:56:28
 * To change this template use File | Settings | File Templates.
 */
public class URLLogProvider implements LogProvider {
    private static final Logger logger = Logger.getLogger("INFRA."+URLLogProvider.class.getName());
    private final URL url;

    public URLLogProvider(URL url) {
        this.url = url;
    }

    public List getEvents(ProgressIndicatorNeutral monitor, int min, int max) throws IOException {
        if (logger.isDebugEnabled()) {
            logger.debug("loading "+this);
        }
        LogReader r = new URLLogReader(this, url, monitor, min, max);
        try {
            return r.parse();
        } finally {
            monitor.setProgress(max);
        }
    }

    public boolean isTransient() {
        return false;
    }

    public String toString() {
        return url.toString();
    }

    public int hashCode() {
        return url.hashCode();
    }

    public boolean equals(Object obj) {
        return (obj instanceof URLLogProvider && url.equals(((URLLogProvider) obj).url));
    }
}
