package com.hsbc.hbfr.ccf.at.logreader.model;

import org.apache.log4j.Logger;

import javax.swing.*;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.URL;
import java.util.List;

import com.hsbc.hbfr.ccf.at.logreader.ui.ProgressIndicatorNeutral;

/**
 * Created by IntelliJ IDEA.
 * User: E9310750
 * Date: 10 mai 2005
 * Time: 16:15:53
 * To change this template use File | Settings | File Templates.
 */
public class URLLogReader extends LogReader {
    private static final Logger logger = Logger.getLogger("INFRA."+URLLogReader.class.getName());
    private final URL url;
    private final LogProvider provider;

    public URLLogReader(URLLogProvider aProvider, URL url, ProgressIndicatorNeutral monitor, int min, int max)  {
        super(monitor, min, max, 0);
        this.url = url;
        provider = aProvider;
    }

    public List parse() throws IOException {
        long start = System.currentTimeMillis();
        List l = super.parse(new InputStreamReader(url.openStream()));
        long end = System.currentTimeMillis();
        logger.debug("parsed [" + url + "] in " + (end - start) + " milliseconds");
        return l;
    }

    protected SimpleLogEvent createEvent(String eventString) {
        return new ProvidedEvent(provider, eventString);
    }
}
