package com.hsbc.hbfr.ccf.at.logreader.predicate;


import org.apache.log4j.Logger;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

import com.hsbc.hbfr.ccf.at.logreader.model.SimpleLogEvent;

/**
 * Created by IntelliJ IDEA.
 * User: Administrateur
 * Date: 4 mai 2005
 * Time: 22:46:32
 * To change this template use File | Settings | File Templates.
 */
public class PredicateDateAfter implements Predicate {
	private static final Logger logger = Logger.getLogger("INFRA."+PredicateDateAfter.class.getName());
	private static final Date ORIGINE = new Date(0);
	private Date from;
	private final SimpleDateFormat df = new SimpleDateFormat(SimpleLogEvent.DATE_PATTERN);

	public PredicateDateAfter() {
		this(new Date(0));
	}

	private PredicateDateAfter(Date from) {
		this.from = from;
	}

	public boolean evaluate(Object e) {
		Date d = (Date) e;
		return d.compareTo(from) >= 0;
	}

	public void fromString(String s) {
		if (s.length() ==0) {
			from=ORIGINE;
		} else {
			try {
				from = df.parse(s);
			} catch (ParseException e) {
				logger.info("[" + s + "] is not parseable with [" + df.toPattern() + "] : " + e.getMessage() + ", index=" + e.getErrorOffset());
				from = ORIGINE;
			}
		}
	}

	public void setDatePattern(String s) {
		df.applyPattern(s);
//		try {
//			System.out.println(df.toPattern()+";"+df.format(from)+";"+df.parse(df.format(from)));
//		} catch (ParseException e) {
//			System.err.println("bad pattern "+ e.getMessage());
//		}
	}

	public String toString() {
		return df.format(from);
	}

	public static void main(String[] args) {
		PredicateDateAfter pred = new PredicateDateAfter();
		System.out.println(pred.from);

		pred.setDatePattern("yyyy MM dd");
		pred.fromString("2005 05 05");
		System.out.println(pred.from);
	}
}
