package com.hsbc.hbfr.ccf.at.logreader.predicate;

import org.apache.log4j.Logger;
import org.apache.regexp.RE;
import org.apache.regexp.RESyntaxException;
import com.hsbc.hbfr.ccf.at.logreader.ui.MessageUtils;


/**
 * Created by IntelliJ IDEA.
 * User: Administrateur
 * Date: 4 mai 2005
 * Time: 22:46:09
 * To change this template use File | Settings | File Templates.
 */
public class PredicateStringLike implements Predicate {
    private static final Logger logger = Logger.getLogger("INFRA."+PredicateDateAfter.class.getName());
    private org.apache.regexp.RE regExp;
    private String pattern;


    public PredicateStringLike() {
        this("");
    }

    private PredicateStringLike(String pattern) {
        fromString(pattern);
    }

    public boolean evaluate(Object e) {
        return (pattern.length()>0)?
            regExp.match(e.toString()): true;
    }

    public void fromString(String s) {
        logger.debug("fromString ("+s+")");
        try {
            regExp = new RE(s);
            pattern = s;
        } catch (RESyntaxException e) {
            logger.error(
                    MessageUtils.getErrorMessage(MessageUtils.invalid_regexp, s), e);
            regExp = new RE(pattern);
        }
    }

    public String toString() {
        return pattern;
    }
}
