package com.hsbc.hbfr.ccf.at.logreader.ui;

import java.text.MessageFormat;
import java.util.ResourceBundle;
import java.util.MissingResourceException;
import java.util.Enumeration;

/**
 * Created by IntelliJ IDEA.
 * User: Administrateur
 * Date: 15 juin 2005
 * Time: 08:31:39
 * To change this template use File | Settings | File Templates.
 */
public class MessageUtils {
    static ResourceBundle errorMessages ;
    static ResourceBundle uiMessages;
    public static final String cant_read_log_file = "errormessages.cant_read_log_file";
    public static final String error_closing_stream="errormessages.error_closing_stream";
    public static final String unparseable_log_event="errormessages.unparseable_log_event";
    public static final String bad_start_of_event="errormessages.bad_start_of_event";
    public static final String bad_date_format="errormessages.bad_date_format";
    public static final String invalid_regexp="errormessages.invalid_regexp";
    public static final String menu_file = "menu.file";
    public static final String menu_file_close = "menu.file.close";
    public static final String menu_file_configuration_load= "menu.file.configuration.load";
    public static final String menu_file_configuration_save= "menu.file.configuration.save";
    public static final String menu_file_configuration_saveas = "menu.file.configuration.saveas";
    public static final String menu_colors= "menu.colors";
    public static final String menu_providers = "menu.providers";
    public static final String menu_spawn= "menu.spawn";
    public static final String menu_file_openfile= "menu.file.openfile";
    public static final String menu_file_openurl= "menu.file.openurl";
    public static final String menu_file_refresh= "menu.file.refresh";
    public static final String menu_file_exit= "menu.file.exit";


    static {
        try {
            errorMessages = ResourceBundle.getBundle(MessageUtils.class.getPackage().getName()+".errormessages");
//            errorMessages = ResourceBundle.getBundle("errormessages");
            uiMessages = ResourceBundle.getBundle(MessageUtils.class.getPackage().getName()+".uimessages");
//            uiMessages = ResourceBundle.getBundle("uimessages");
        } catch (MissingResourceException e) {
            System.err.println("can't find externalized messages");
            e.printStackTrace();
        }
    }
    public static String getUIMessage(String messageId){
        return uiMessages.getString(messageId);
    }
    public static String getErrorMessage(String messageId){
        return uiMessages.getString(messageId);
    }
    public static String getUIMessage(String messageId, String param){
        String message = getUIMessage(messageId);
        return MessageFormat.format(message, new String[]{param});
    }
    public static String getErrorMessage(String messageId, String param){
        String message =  getErrorMessage(messageId);
        return MessageFormat.format(message, new String[]{param});
    }

    public static String getUIMessage(String messageId, String param1, String param2){
        String message = getUIMessage(messageId);
        return MessageFormat.format(message, new String[]{param1, param2});
    }
    public static String getErrorMessage(String messageId, String param1, String param2){
        String message =  getErrorMessage(messageId);
        return MessageFormat.format(message, new String[]{param1, param2});
    }

    public static void main(String[] args) {
        ResourceBundle bundle = ResourceBundle.getBundle(MessageUtils.class.getPackage().getName() + ".errormessages");
        Enumeration enum = bundle.getKeys();
        while (enum.hasMoreElements()) {
            String key = (String) enum.nextElement();
            String value = getErrorMessage(key);
            System.err.println("key : "+key+",value: "+value);
        }
        System.err.println(MessageUtils.getErrorMessage(cant_read_log_file));
    }
}
