package com.hsbc.hbfr.ccf.at.logreader.ui;

import com.hsbc.hbfr.ccf.at.logreader.predicate.PredicateDateAfter;
import com.hsbc.hbfr.ccf.at.logreader.predicate.PredicateStringLike;
import com.hsbc.hbfr.ccf.at.logreader.predicate.NegatablePredicate;
import com.hsbc.hbfr.ccf.at.logreader.predicate.NegatableStringLikePredicate;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 * Created by IntelliJ IDEA.
 * User: Administrateur
 * Date: 12 mai 2005
 * Time: 22:10:42
 * To change this template use File | Settings | File Templates.
 */
public class StringFilterInputPanel extends JPanel implements FilterInput {
    private final class EventListener implements ActionListener,ItemListener {
    public void actionPerformed(ActionEvent e) {
        if (e.getActionCommand().equals("comboBoxChanged")) {
             Object selectedItem = filtreCb.getSelectedItem();
             if (model.getIndexOf(selectedItem) < 0) {
                 model.addElement(selectedItem);
             } else {
             }
                predicate.fromString(model.getSelectedItem().toString());
            fireActionEvent(new ActionEvent(this, 0, "filter changed"));
         } else if (e.getActionCommand().equals("comboBoxEdited")) {
         }
    }
    public void itemStateChanged(ItemEvent e) {
        predicate.setNegated(negateBn.isSelected());
         fireActionEvent(new ActionEvent(this, 0, "filter changed"));
    }
    }
    private static final int historyCount = 10;
    private final EventListener listener =  new EventListener();
    private JLabel titleLb;
    private JComboBox filtreCb;
    private JToggleButton negateBn;
    private MaxSizeComboBoxModel model;
    private ActionListener listeners = null;
    private final NegatablePredicate predicate;
    public StringFilterInputPanel(NegatablePredicate aPredicate, String title, int nbMaxChars) {
        this(aPredicate, title);
        setMaximumFilterLength(nbMaxChars);
    }

    public StringFilterInputPanel(NegatablePredicate aPredicate, String title) {
        super (new BorderLayout());
        predicate = aPredicate;
        titleLb = new JLabel(title);
        negateBn = new JToggleButton("!");
        negateBn.setMargin(new Insets(1,1,2,1));
        model = new MaxSizeComboBoxModel(historyCount);
        filtreCb = new JComboBox( model);
        filtreCb.setEditable(true);

        JPanel p = new JPanel();
        p.setLayout(new BorderLayout());
        p.add(titleLb, BorderLayout.WEST);
        p.add(negateBn, BorderLayout.EAST);
        add(p, BorderLayout.NORTH);
        add(filtreCb, BorderLayout.SOUTH);
        initEvents();
    }

     private void initEvents() {
        filtreCb.addActionListener(listener);
        negateBn.addItemListener(listener);
    }

    public String getText() {
        Object selectedItem = filtreCb.getSelectedItem();
        return (selectedItem==null)?"":selectedItem.toString();
    }
    public void addFilter(String s, int index) {
        model.insertElementAt(s, index);
    }
    public void setText(String s) {
        filtreCb.setSelectedItem(s);
    }
    public String[] getRecentTexts() {
        String[] options  = new String[filtreCb.getModel().getSize()];
        for (int i =0, max = options.length;i<max;i++) {
            options[i] =filtreCb.getModel().getElementAt(i).toString();
        }
        return options;
    }
    public void addActionListener(ActionListener l) {
        listeners = AWTEventMulticaster.add(listeners, l);
    }
    public void removeActionListener(ActionListener l) {
       listeners = AWTEventMulticaster.remove(listeners, l);
    }
    protected void fireActionEvent(ActionEvent event){
        if (listeners != null) {
            listeners.actionPerformed(event);
        }
    }
    public static void main(String[] args) {
        JFrame f = new JFrame();
        f.setSize(200, 200);
        f.getContentPane().setLayout( new BorderLayout());
        JPanel p = new JPanel();
        p.setLayout(new GridBagLayout());
        String[] titres = {"categorie","thread","priorit","date","message"};
        for (int i = 0; i < titres.length; i++) {
            String titre = titres[i];
            final StringFilterInputPanel panel = new StringFilterInputPanel(new NegatableStringLikePredicate(), titres[i]);
            panel.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    System.err.println("actionPerformed [text = "+panel.getText()+", negated="+panel.negateBn.isSelected()+"]");
                }
            });
            p.add(panel, new GridBagConstraints(i,0,1,1,1,1,GridBagConstraints.CENTER,GridBagConstraints.BOTH,new Insets(0,2,0,2),0,0));

        }
        f.getContentPane().add(p,BorderLayout.NORTH);
        f.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
        f.setVisible(true);
    }

    private void setMaximumFilterLength(int nbChars) {
        StringBuffer template= new StringBuffer(nbChars);
        for (int i = 0;i< nbChars;i++) {
            template.append("a");
        }
        filtreCb.setModel(new DefaultComboBoxModel(new String[]{template.toString()}));
        Dimension size = filtreCb.getPreferredSize();
        filtreCb.setModel(model);
        filtreCb.setPreferredSize(size);
        filtreCb.setMaximumSize(size);
    }

}
